<!DOCTYPE html>

<script>

    let $ = require('jquery')
    require('popper.js');
    require('bootstrap');
    require('chart.js')
    socket = require('net');
    const storage = require('electron-json-storage-sync');
    const { session } = require('electron').remote;
    const { dialog } = require('electron').remote;
    const parse = require("csv-parse")
    var fs = require('fs');
    dt = require( 'datatables.net-bs4' )( window, $ );
    require( 'datatables.net-select-bs4' )( window, $ );



</script>

<html>
<head>
    <meta charset="UTF-8">
    <title>Wuerfelsort</title>
    <link rel="stylesheet" href="./contents/bootstrap-4.3.1-dist/css/bootstrap.min.css"/>
    <link rel="stylesheet" href="./contents/fontawesome/all.css"/>

    <link rel="stylesheet" href="./node_modules/datatables.net-bs4/css/dataTables.bootstrap4.min.css"/>
    <link rel="stylesheet" href="./node_modules/datatables.net-select-bs4/css/select.bootstrap4.min.css"/>
</head>
<body>
<div class="container">
    <div class="row">
        <div class="card col-12 ">
            <div class="text-center card-body p-3">
                <h4>Folding@Home Cluster-Control</h4>
            </div>
        </div>
        <ul class="nav nav-tabs nav-fill">
            <li class="nav-item"><a class="nav-link active" data-toggle="tab" href="#clientsPage">Control</a></li>
            <li class="nav-item"><a class="nav-link" data-toggle="tab" href="#addClientPage">Clients</a></li>
            <!--<li class="nav-item"><a class="nav-link" data-toggle="tab" href="#">Menu 2</a></li>-->
            <li class="nav-item"><a class="nav-link" data-toggle="tab" href="#profilesPage">Profiles</a></li>
        </ul>
    </div>


    <div class="tab-content" >
        <div class="tab-pane fade show active" id="clientsPage">
            <div class="row">
                <div class="card col-12">
                    <div class="card-body">
                        <div id="toolbar">
                            <button id="remove" class="btn btn-danger" disabled>
                                Delete
                            </button>
                            <button id="shutdown" class="btn btn-danger" disabled>
                                Shutdown
                            </button>
                            <div class="btn-group" role="group">
                                <button id="disconnect" class="btn btn-danger pr-1">
                                    Dis-
                                </button>
                                <button id="connect" class="btn btn-success pl-1">
                                    Connnect
                                </button>
                            </div>
                            <div class="btn-group" role="group">
                                <button id="unpause" class="btn btn-success pr-1">
                                    Resume
                                </button>
                                <button id="unpauseCPU" class="btn btn-success px-1">
                                    CPU
                                </button>
                                <button id="unpauseGPU" class="btn btn-success pl-1">
                                    GPU
                                </button>
                            </div>
                            <div class="btn-group" role="group">
                                <button id="pause" class="btn btn-warning pr-1">
                                    Pause
                                </button>
                                <button id="pauseCPU" class="btn btn-warning px-1">
                                    CPU
                                </button>
                                <button id="pauseGPU" class="btn btn-warning pl-1">
                                    GPU
                                </button>
                            </div>
                            <div class="btn-group" role="group">
                                <button id="finish" class="btn btn-info pr-1">
                                    Finish
                                </button>
                                <button id="finishCPU" class="btn btn-info px-1">
                                    CPU
                                </button>
                                <button id="finishGPU" class="btn btn-info pl-1">
                                    GPU
                                </button>
                            </div>
                        </div>

                        <br>
                        <table id="clientTable" style="width:100%" class="table table-striped table-sm">
                            <thead>
                                <tr>
                                    <th></th>
                                    <th>Name</th>
                                    <th>Host</th>
                                    <th>Info</th>
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div class="row d-none" id="crow" >
                <div class="card col-12">
                    <div class="card-body">
                        <h4 class="mb-0">Configuration (local)</h4>
                        <table class="table table-sm">
                            <tr>
                                <td><label for="cname">Name</label></td>
                                <td><input class="form-control" id="cname"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('name')"><i class="fas fa-check"></i></button></td>
                            </tr>
                            <tr>
                                <td><label for="chost">IP/host</label></td>
                                <td><input class="form-control" id="chost"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('host')"><i class="fas fa-check"></i></button></td>
                            </tr>
                            <tr>
                                <td><label for="cport">Port</label></td>
                                <td><input type="number" class="form-control" id="cport"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('port')"><i class="fas fa-check"></i></button></td>
                            </tr>
                            <tr>
                                <td><label for="cpassword">Password</label></td>
                                <td><input class="form-control" id="cpassword"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('password')"><i class="fas fa-check"></i></button></td>
                            </tr>
                        </table>
                        <h4 class="mb-0">Configuration (remote)</h4>
                        <table class="table table-sm">
                            <tr>
                                <td><label for="cuser">username</label></td>
                                <td><input class="form-control" id="cuser"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('user')"><i class="fas fa-check"></i></button></td>
                            </tr>
                            <tr>
                                <td><label for="cpasskey">passkey</label></td>
                                <td><input class="form-control" id="cpasskey"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('passkey')"><i class="fas fa-check"></i></button></td>
                            </tr>
                            <tr>
                                <td><label for="cteam">team</label></td>
                                <td><input type="number" class="form-control" id="cteam"></td>
                                <td></td>
                                <td><button class="btn btn-sm btn-success" title="Apply to all selected clients" onclick="applyConfig('team')"><i class="fas fa-check"></i></button></td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
            <div class="row" id="chartRow" >
                <div class="card col-6">
                    <div class="card-body">
                        <canvas id="connectionChart" width="400" height="400"></canvas>
                    </div>
                </div>
                <div class="card col-6">
                    <div class="card-body">
                        <canvas id="someChart" width="400" height="400"></canvas>
                    </div>
                </div>
            </div>
        </div>

        <div class="tab-pane fade" id="addClientPage">
            <div class="row">
                <div class="card col-6 drop-area">
                    <div class="card-body">
                        <h4 class="mb-0">Add Client</h4>
                        <table class="table table-sm">
                            <tr><td><label for="addName">Name(local)</label></td><td><input class="form-control" id="addName"></td></tr>
                            <tr><td><label for="addHost">IP/Hostname</label></td><td><input class="form-control" id="addHost"></td></tr>
                            <tr><td><label for="addPort">Port</label></td><td><input class="form-control" id="addPort"></td></tr>
                            <tr><td><label for="addPass">Password</label></td><td><input class="form-control" id="addPass"></td></tr>
                            <tr><td>Add to list</td><td><button class="btn btn-success" onclick="addClientsFromUi()">Add to list</button></tr>
                        </table>
                    </div>
                </div>
                <div class="card col-6 drop-area">
                    <div class="card-body">
                        <h4 class="mb-0">Export/Import CSV</h4><br>
                        <p>
                            <button class="btn btn-success" onclick="importClients()">Import</button><br>
                            Used to add many clients at once. Import csv files with name, ip/host, port and password. If one is N/A, leave blank. Clients with same name will be overwritten.
                        </p>
                        <p>
                            <button class="btn btn-success" onclick="exportClients()">Export</button><br>
                            Exports all current clients to csv. Use this as template for importing.
                        </p>

                    </div>
                </div>
            </div>
        </div>

        <div class="tab-pane fade" id="profilesPage">
            <div class="row">
                <div class="card col-6">
                    <div class="card-body">
                        <h4>Active Profile</h4>
                        <table class="table table-sm" id="profilesTable">

                        </table>
                    </div>
                </div>
                <div class="card col-6">
                    <div class="card-body">
                        <h4>New Profile</h4>
                        <table class="table table-sm">
                            <tr><td><label for="controllerName">Name</label></td><td><input class="form-control" id="controllerName"></td></tr>
                            <tr><td>Add to list</td><td><button class="btn btn-success" onclick="controllers.addControllerFromUi()">Create</button></tr>
                        </table>
                    </div>
                </div>
                <div class="card col-12">
                    <div class="card-body">
                        <h4>Proxy</h4>
                        <table class="table table-sm">
                            <tr><td><label for="proxyHost">IP/Host</label></td><td><input class="form-control" id="proxyHost"></td></tr>
                            <tr><td><label for="proxyPort">Port</label></td><td><input class="form-control" id="proxyPort"></td></tr>
                            <tr><td></td><td><button class="btn btn-success" onclick="setProxyFromUi()">Change proxy of selected profile</button></tr>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>

<script src="./Controller.js"></script>
<script src="./Client.js"></script>
<script src="./Slot.js"></script>
<script src="./Controllers.js"></script>


<script>

    async function init(){ //TODO: Async
        if(storage.has("controllers").data && typeof fetch("controllers") === "object" && fetch("controllers").length > 0){
            fetch("controllers").forEach( (entry) => {
                controllers.push(new Controller(entry));
            });
        }else{
            let controller = new Controller();
            controller.name = "Profile1";
            controller.selected = true;
            controllers.push(controller);
            controllers.save()
        }
        controllers.selectController(controllers.selected.name);
    }


    async function applyConfig(cParam){ //TODO: Async
        controllers.selected.selecedClients.forEach((client) => {
            client.setOption(cParam, $(`#c${cParam}`).val())
        })
    }

    function detailFormatter(index, client) {
        return `Hier müssen noch mehr informationen hin! ${client.connected}`
    }

    async function updateActiveController(){ //TODO: Async
        let header = "<tr><th>Name</th><th></th><th></th><th>Proxy</th></tr>"
        $("#profilesTable").html(header + $.map(controllers, function(controller){
            if(controller.selected) {
                return `<tr><td>${controller.name}</td><td><button class="btn btn-sm btn-success" disabled onclick="controllers.selectController('${controller.name}')">SELECTED</button></td><td><button class="btn btn-sm btn-danger" onclick="controllers.delController('${controller.name}')">DELETE</button></td><td>${controller.proxyHost}:${controller.proxyPort}</td></tr>`
            }else {
                return `<tr><td>${controller.name}</td><td><button class="btn btn-sm btn-success" onclick="controllers.selectController('${controller.name}')">SELECT</button></td><td><button class="btn btn-sm btn-danger" onclick="controllers.delController('${controller.name}')">DELETE</button></td><td>${controller.proxyHost}:${controller.proxyPort}</td></tr>`
            }
        }).join(''))
    }

    async function addClientsFromUi(){ //TODO: Async
        let addName = $("#addName").val()
        let addHost = $("#addHost").val()
        let addPort = $("#addPort").val()
        let addPass = $("#addPass").val()
        if(addName.length === 0 || addHost.length === 0){
            console.error("The required inputs must be filled")
            return null
        }
        if(addPort.length === 0){ addPort = 36330 }else{ addPort = Number(addPort) }
        let client = new Client()
        client.fromArgs(addName, addHost, addPort, addPass, controllers.selected, controllers.selected.newClientId())
        controllers.selected.addClient(client)
    }

    async function setProxyFromUi(){
        controllers.selected.proxyHost = $("#proxyHost").val();
        controllers.selected.proxyPort = $("#proxyPort").val();
        updateActiveController()
        controllers.save()
    }

    async function exportClients(){ //TODO: Async
        dialog.showSaveDialog((fileName) => {
            if (fileName === undefined){ return; }
            const createCsvWriter = require('csv-writer').createObjectCsvWriter;
            const csvWriter = createCsvWriter({
                path: fileName,
                header: [
                    {id: 'name', title: 'name'},
                    {id: 'host', title: 'host'},
                    {id: 'port', title: 'port'},
                    {id: 'password', title: 'password'},
                ]
            });
            csvWriter
                .writeRecords(controllers.selected.clients)
                .then(()=> console.log('The CSV file was written successfully'));
        });

    }

    async function importClients(){ //TODO: Async
        dialog.showOpenDialog({ properties: ['openFile'], filters: [{name: 'CSV', extensions: ['csv']},{ name: 'All Files', extensions: ['*'] }] }).then( (path) => {
            if(typeof path === "undefined") return
            fs.readFile(path.filePaths[0], 'utf8', (err, data) => {
                if (err) return console.log(err);
                const output = [];
                parse(data,{
                    trim: true,
                    skip_empty_lines: true
                }).on('readable', function(){
                    let record;
                    while (record = this.read()) {
                        output.push(record)
                    }
                })
                // When we are done, test that the parsed output matched what expected
                .on('end', function(){
                    output.forEach((row) => {
                        let client = new Client()
                        client.fromArgs(row[0], row[1], row[2], row[3], controllers.selected, controllers.selected.newClientId())
                        controllers.selected.clients.push(client)
                        controllers.selected.reloadClientTable();
                        controllers.save()
                    })
                });
            })

        });
    }



    function parseTime(timeString){
        let timeRegex = /^(?:(\d{0,5}(?:\.\d{0,2})?) days)? ?(?:(\d{0,2}) hours)? ?(?:(\d{0,2}) mins)? ?(?:(\d{0,2}(?:\.\d{0,2})?) secs)?$/m
        let match = timeString.matchAll(timeRegex).next()
        let secs = 0
        if(typeof match.value !== "undefined"){
            if(typeof match.value[1] !== "undefined"){
                secs += Number(match.value[1]) * 24 * 60 * 60 *1000
            }
            if(typeof match.value[2] !== "undefined"){
                secs += Number(match.value[2]) * 60 * 60 *1000
            }
            if(typeof match.value[3] !== "undefined"){
                secs += Number(match.value[3]) * 60 *1000
            }
            if(typeof match.value[4] !== "undefined"){
                secs += Number(match.value[4]) * 1000
            }
        }
        return new Date((new Date()).getTime() + secs);
    }

    function fetch(key){
        if(storage.has(key).data) {
            return JSON.parse(storage.get(key)["data"]);
        }
    }
    function save(key, value) {
        storage.set(key, JSON.stringify(value));
    }

    /*nmap.scan({
        ports:"36330",
        range: ['192.168.3.0/24']
    }, function(err, report) {
        if (err) throw new Error(err);

        let hosts = [];
        for (let key in report){
            let item = report[key];
            if(typeof item.host !== "undefined") {
                for (let key2 in item.host){
                    let host = item.host[key2];
                    if(host.ports[0].port[0].state[0].item.state === "open") {
                        hosts.push({
                            adress: host.address[0].item.addr,
                            hostname: host.hostnames[0].hostname[0].item.name
                        })
                    }
                }
            }
        }

        console.log(hosts)
    });*/


    let controllers = new Controllers();
    init()

</script>


<!--<style>
    /*
    * Table styles
    */
    table.dataTable {
    width: 100%;
    margin: 0 auto;
    clear: both;
    border-collapse: separate;
    border-spacing: 0;
    /*
    * Header and footer styles
    */
    /*
    * Body styles
    */ }
    table.dataTable thead th,
    table.dataTable tfoot th {
    font-weight: bold; }
    table.dataTable thead th,
    table.dataTable thead td {
    padding: 10px 18px;
    border-bottom: 1px solid white; }
    table.dataTable thead th:active,
    table.dataTable thead td:active {
    outline: none; }
    table.dataTable tfoot th,
    table.dataTable tfoot td {
    padding: 10px 18px 6px 18px;
    border-top: 1px solid white; }
    table.dataTable thead .sorting,
    table.dataTable thead .sorting_asc,
    table.dataTable thead .sorting_desc,
    table.dataTable thead .sorting_asc_disabled,
    table.dataTable thead .sorting_desc_disabled {
    cursor: pointer;
    *cursor: hand;
    background-repeat: no-repeat;
    background-position: center right; }
    table.dataTable thead .sorting {
    background-image: url("../images/sort_both.png"); }
    table.dataTable thead .sorting_asc {
    background-image: url("../images/sort_asc.png"); }
    table.dataTable thead .sorting_desc {
    background-image: url("../images/sort_desc.png"); }
    table.dataTable thead .sorting_asc_disabled {
    background-image: url("../images/sort_asc_disabled.png"); }
    table.dataTable thead .sorting_desc_disabled {
    background-image: url("../images/sort_desc_disabled.png"); }
    table.dataTable tbody tr {
    background-color: #2b2b2b; }
    table.dataTable tbody tr.selected {
    background-color: #164a03; }
    table.dataTable tbody th,
    table.dataTable tbody td {
    padding: 8px 10px; }
    table.dataTable.row-border tbody th, table.dataTable.row-border tbody td, table.dataTable.display tbody th, table.dataTable.display tbody td {
    border-top: 1px solid black; }
    table.dataTable.row-border tbody tr:first-child th,
    table.dataTable.row-border tbody tr:first-child td, table.dataTable.display tbody tr:first-child th,
    table.dataTable.display tbody tr:first-child td {
    border-top: none; }
    table.dataTable.cell-border tbody th, table.dataTable.cell-border tbody td {
    border-top: 1px solid black;
    border-right: 1px solid black; }
    table.dataTable.cell-border tbody tr th:first-child,
    table.dataTable.cell-border tbody tr td:first-child {
    border-left: 1px solid black; }
    table.dataTable.cell-border tbody tr:first-child th,
    table.dataTable.cell-border tbody tr:first-child td {
    border-top: none; }
    table.dataTable.stripe tbody tr.odd, table.dataTable.display tbody tr.odd {
    background-color: #292929; }
    table.dataTable.stripe tbody tr.odd.selected, table.dataTable.display tbody tr.odd.selected {
    background-color: #154802; }
    table.dataTable.hover tbody tr:hover, table.dataTable.display tbody tr:hover {
    background-color: #292929; }
    table.dataTable.hover tbody tr:hover.selected, table.dataTable.display tbody tr:hover.selected {
    background-color: #154702; }
    table.dataTable.order-column tbody tr > .sorting_1,
    table.dataTable.order-column tbody tr > .sorting_2,
    table.dataTable.order-column tbody tr > .sorting_3, table.dataTable.display tbody tr > .sorting_1,
    table.dataTable.display tbody tr > .sorting_2,
    table.dataTable.display tbody tr > .sorting_3 {
    background-color: #2a2a2a; }
    table.dataTable.order-column tbody tr.selected > .sorting_1,
    table.dataTable.order-column tbody tr.selected > .sorting_2,
    table.dataTable.order-column tbody tr.selected > .sorting_3, table.dataTable.display tbody tr.selected > .sorting_1,
    table.dataTable.display tbody tr.selected > .sorting_2,
    table.dataTable.display tbody tr.selected > .sorting_3 {
    background-color: #154802; }
    table.dataTable.display tbody tr.odd > .sorting_1, table.dataTable.order-column.stripe tbody tr.odd > .sorting_1 {
    background-color: #282828; }
    table.dataTable.display tbody tr.odd > .sorting_2, table.dataTable.order-column.stripe tbody tr.odd > .sorting_2 {
    background-color: #282828; }
    table.dataTable.display tbody tr.odd > .sorting_3, table.dataTable.order-column.stripe tbody tr.odd > .sorting_3 {
    background-color: #292929; }
    table.dataTable.display tbody tr.odd.selected > .sorting_1, table.dataTable.order-column.stripe tbody tr.odd.selected > .sorting_1 {
    background-color: #144602; }
    table.dataTable.display tbody tr.odd.selected > .sorting_2, table.dataTable.order-column.stripe tbody tr.odd.selected > .sorting_2 {
    background-color: #144602; }
    table.dataTable.display tbody tr.odd.selected > .sorting_3, table.dataTable.order-column.stripe tbody tr.odd.selected > .sorting_3 {
    background-color: #154702; }
    table.dataTable.display tbody tr.even > .sorting_1, table.dataTable.order-column.stripe tbody tr.even > .sorting_1 {
    background-color: #2a2a2a; }
    table.dataTable.display tbody tr.even > .sorting_2, table.dataTable.order-column.stripe tbody tr.even > .sorting_2 {
    background-color: #2a2a2a; }
    table.dataTable.display tbody tr.even > .sorting_3, table.dataTable.order-column.stripe tbody tr.even > .sorting_3 {
    background-color: #2a2a2a; }
    table.dataTable.display tbody tr.even.selected > .sorting_1, table.dataTable.order-column.stripe tbody tr.even.selected > .sorting_1 {
    background-color: #154802; }
    table.dataTable.display tbody tr.even.selected > .sorting_2, table.dataTable.order-column.stripe tbody tr.even.selected > .sorting_2 {
    background-color: #154902; }
    table.dataTable.display tbody tr.even.selected > .sorting_3, table.dataTable.order-column.stripe tbody tr.even.selected > .sorting_3 {
    background-color: #154902; }
    table.dataTable.display tbody tr:hover > .sorting_1, table.dataTable.order-column.hover tbody tr:hover > .sorting_1 {
    background-color: #272727; }
    table.dataTable.display tbody tr:hover > .sorting_2, table.dataTable.order-column.hover tbody tr:hover > .sorting_2 {
    background-color: #272727; }
    table.dataTable.display tbody tr:hover > .sorting_3, table.dataTable.order-column.hover tbody tr:hover > .sorting_3 {
    background-color: #282828; }
    table.dataTable.display tbody tr:hover.selected > .sorting_1, table.dataTable.order-column.hover tbody tr:hover.selected > .sorting_1 {
    background-color: #144302; }
    table.dataTable.display tbody tr:hover.selected > .sorting_2, table.dataTable.order-column.hover tbody tr:hover.selected > .sorting_2 {
    background-color: #144402; }
    table.dataTable.display tbody tr:hover.selected > .sorting_3, table.dataTable.order-column.hover tbody tr:hover.selected > .sorting_3 {
    background-color: #144502; }
    table.dataTable.no-footer {
    border-bottom: 1px solid white; }
    table.dataTable.nowrap th, table.dataTable.nowrap td {
    white-space: nowrap; }
    table.dataTable.compact thead th,
    table.dataTable.compact thead td {
    padding: 4px 17px 4px 4px; }
    table.dataTable.compact tfoot th,
    table.dataTable.compact tfoot td {
    padding: 4px; }
    table.dataTable.compact tbody th,
    table.dataTable.compact tbody td {
    padding: 4px; }
    table.dataTable th.dt-left,
    table.dataTable td.dt-left {
    text-align: left; }
    table.dataTable th.dt-center,
    table.dataTable td.dt-center,
    table.dataTable td.dataTables_empty {
    text-align: center; }
    table.dataTable th.dt-right,
    table.dataTable td.dt-right {
    text-align: right; }
    table.dataTable th.dt-justify,
    table.dataTable td.dt-justify {
    text-align: justify; }
    table.dataTable th.dt-nowrap,
    table.dataTable td.dt-nowrap {
    white-space: nowrap; }
    table.dataTable thead th.dt-head-left,
    table.dataTable thead td.dt-head-left,
    table.dataTable tfoot th.dt-head-left,
    table.dataTable tfoot td.dt-head-left {
    text-align: left; }
    table.dataTable thead th.dt-head-center,
    table.dataTable thead td.dt-head-center,
    table.dataTable tfoot th.dt-head-center,
    table.dataTable tfoot td.dt-head-center {
    text-align: center; }
    table.dataTable thead th.dt-head-right,
    table.dataTable thead td.dt-head-right,
    table.dataTable tfoot th.dt-head-right,
    table.dataTable tfoot td.dt-head-right {
    text-align: right; }
    table.dataTable thead th.dt-head-justify,
    table.dataTable thead td.dt-head-justify,
    table.dataTable tfoot th.dt-head-justify,
    table.dataTable tfoot td.dt-head-justify {
    text-align: justify; }
    table.dataTable thead th.dt-head-nowrap,
    table.dataTable thead td.dt-head-nowrap,
    table.dataTable tfoot th.dt-head-nowrap,
    table.dataTable tfoot td.dt-head-nowrap {
    white-space: nowrap; }
    table.dataTable tbody th.dt-body-left,
    table.dataTable tbody td.dt-body-left {
    text-align: left; }
    table.dataTable tbody th.dt-body-center,
    table.dataTable tbody td.dt-body-center {
    text-align: center; }
    table.dataTable tbody th.dt-body-right,
    table.dataTable tbody td.dt-body-right {
    text-align: right; }
    table.dataTable tbody th.dt-body-justify,
    table.dataTable tbody td.dt-body-justify {
    text-align: justify; }
    table.dataTable tbody th.dt-body-nowrap,
    table.dataTable tbody td.dt-body-nowrap {
    white-space: nowrap; }

    table.dataTable,
    table.dataTable th,
    table.dataTable td {
    box-sizing: content-box; }

    /*
    * Control feature layout
    */
    .dataTables_wrapper {
    position: relative;
    clear: both;
    *zoom: 1;
    zoom: 1; }
    .dataTables_wrapper .dataTables_length {
    float: left; }
    .dataTables_wrapper .dataTables_filter {
    float: right;
    text-align: right; }
    .dataTables_wrapper .dataTables_filter input {
    margin-left: 0.5em; }
    .dataTables_wrapper .dataTables_info {
    clear: both;
    float: left;
    padding-top: 0.755em; }
    .dataTables_wrapper .dataTables_paginate {
    float: right;
    text-align: right;
    padding-top: 0.25em; }
    .dataTables_wrapper .dataTables_paginate .paginate_button {
    box-sizing: border-box;
    display: inline-block;
    min-width: 1.5em;
    padding: 0.5em 1em;
    margin-left: 2px;
    text-align: center;
    text-decoration: none !important;
    cursor: pointer;
    *cursor: hand;
    color: #ffeded !important;
    border: 1px solid transparent;
    border-radius: 2px; }
    .dataTables_wrapper .dataTables_paginate .paginate_button.current, .dataTables_wrapper .dataTables_paginate .paginate_button.current:hover {
    color: #ffeded !important;
    border: 1px solid #050b1e;
    background-color: #577ce4;
    background: -webkit-gradient(linear, left top, left bottom, color-stop(0%, #577ce4), color-stop(100%, #183994));
    /* Chrome,Safari4+ */
    background: -webkit-linear-gradient(top, #577ce4 0%, #183994 100%);
    /* Chrome10+,Safari5.1+ */
    background: -moz-linear-gradient(top, #577ce4 0%, #183994 100%);
    /* FF3.6+ */
    background: -ms-linear-gradient(top, #577ce4 0%, #183994 100%);
    /* IE10+ */
    background: -o-linear-gradient(top, #577ce4 0%, #183994 100%);
    /* Opera 11.10+ */
    background: linear-gradient(to bottom, #577ce4 0%, #183994 100%);
    /* W3C */ }
    .dataTables_wrapper .dataTables_paginate .paginate_button.disabled, .dataTables_wrapper .dataTables_paginate .paginate_button.disabled:hover, .dataTables_wrapper .dataTables_paginate .paginate_button.disabled:active {
    cursor: default;
    color: #666 !important;
    border: 1px solid transparent;
    background: transparent;
    box-shadow: none; }
    .dataTables_wrapper .dataTables_paginate .paginate_button:hover {
    color: white !important;
    border: 1px solid white;
    background-color: white;
    background: -webkit-gradient(linear, left top, left bottom, color-stop(0%, white), color-stop(100%, white));
    /* Chrome,Safari4+ */
    background: -webkit-linear-gradient(top, white 0%, white 100%);
    /* Chrome10+,Safari5.1+ */
    background: -moz-linear-gradient(top, white 0%, white 100%);
    /* FF3.6+ */
    background: -ms-linear-gradient(top, white 0%, white 100%);
    /* IE10+ */
    background: -o-linear-gradient(top, white 0%, white 100%);
    /* Opera 11.10+ */
    background: linear-gradient(to bottom, white 0%, white 100%);
    /* W3C */ }
    .dataTables_wrapper .dataTables_paginate .paginate_button:active {
    outline: none;
    background-color: white;
    background: -webkit-gradient(linear, left top, left bottom, color-stop(0%, white), color-stop(100%, #fafafa));
    /* Chrome,Safari4+ */
    background: -webkit-linear-gradient(top, white 0%, #fafafa 100%);
    /* Chrome10+,Safari5.1+ */
    background: -moz-linear-gradient(top, white 0%, #fafafa 100%);
    /* FF3.6+ */
    background: -ms-linear-gradient(top, white 0%, #fafafa 100%);
    /* IE10+ */
    background: -o-linear-gradient(top, white 0%, #fafafa 100%);
    /* Opera 11.10+ */
    background: linear-gradient(to bottom, white 0%, #fafafa 100%);
    /* W3C */
    box-shadow: inset 0 0 3px #111; }
    .dataTables_wrapper .dataTables_paginate .ellipsis {
    padding: 0 1em; }
    .dataTables_wrapper .dataTables_processing {
    position: absolute;
    top: 50%;
    left: 50%;
    width: 100%;
    height: 40px;
    margin-left: -50%;
    margin-top: -25px;
    padding-top: 20px;
    text-align: center;
    font-size: 1.2em;
    background-color: white;
    background: -webkit-gradient(linear, left top, right top, color-stop(0%, rgba(43, 43, 43, 0)), color-stop(25%, rgba(43, 43, 43, 0.9)), color-stop(75%, rgba(43, 43, 43, 0.9)), color-stop(100%, rgba(255, 255, 255, 0)));
    background: -webkit-linear-gradient(left, rgba(43, 43, 43, 0) 0%, rgba(43, 43, 43, 0.9) 25%, rgba(43, 43, 43, 0.9) 75%, rgba(43, 43, 43, 0) 100%);
    background: -moz-linear-gradient(left, rgba(43, 43, 43, 0) 0%, rgba(43, 43, 43, 0.9) 25%, rgba(43, 43, 43, 0.9) 75%, rgba(43, 43, 43, 0) 100%);
    background: -ms-linear-gradient(left, rgba(43, 43, 43, 0) 0%, rgba(43, 43, 43, 0.9) 25%, rgba(43, 43, 43, 0.9) 75%, rgba(43, 43, 43, 0) 100%);
    background: -o-linear-gradient(left, rgba(43, 43, 43, 0) 0%, rgba(43, 43, 43, 0.9) 25%, rgba(43, 43, 43, 0.9) 75%, rgba(43, 43, 43, 0) 100%);
    background: linear-gradient(to right, rgba(43, 43, 43, 0) 0%, rgba(43, 43, 43, 0.9) 25%, rgba(43, 43, 43, 0.9) 75%, rgba(43, 43, 43, 0) 100%); }
    .dataTables_wrapper .dataTables_length,
    .dataTables_wrapper .dataTables_filter,
    .dataTables_wrapper .dataTables_info,
    .dataTables_wrapper .dataTables_processing,
    .dataTables_wrapper .dataTables_paginate {
    color: #ffeded; }
    .dataTables_wrapper .dataTables_scroll {
    clear: both; }
    .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody {
    *margin-top: -1px;
    -webkit-overflow-scrolling: touch; }
    .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > thead > tr > th, .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > thead > tr > td, .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > tbody > tr > th, .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > tbody > tr > td {
    vertical-align: middle; }
    .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > thead > tr > th > div.dataTables_sizing,
    .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > thead > tr > td > div.dataTables_sizing, .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > tbody > tr > th > div.dataTables_sizing,
    .dataTables_wrapper .dataTables_scroll div.dataTables_scrollBody > table > tbody > tr > td > div.dataTables_sizing {
    height: 0;
    overflow: hidden;
    margin: 0 !important;
    padding: 0 !important; }
    .dataTables_wrapper.no-footer .dataTables_scrollBody {
    border-bottom: 1px solid white; }
    .dataTables_wrapper.no-footer div.dataTables_scrollHead table.dataTable,
    .dataTables_wrapper.no-footer div.dataTables_scrollBody > table {
    border-bottom: none; }
    .dataTables_wrapper:after {
    visibility: hidden;
    display: block;
    content: "";
    clear: both;
    height: 0; }

    @media screen and (max-width: 767px) {
    .dataTables_wrapper .dataTables_info,
    .dataTables_wrapper .dataTables_paginate {
    float: none;
    text-align: center; }
    .dataTables_wrapper .dataTables_paginate {
    margin-top: 0.5em; } }
    @media screen and (max-width: 640px) {
    .dataTables_wrapper .dataTables_length,
    .dataTables_wrapper .dataTables_filter {
    float: none;
    text-align: center; }
    .dataTables_wrapper .dataTables_filter {
    margin-top: 0.5em; } }
</style>-->